PUBLIC g_ShellPid
.data
g_ShellPid	HANDLE ?

.code
; [rEsp]:
;	@Fret	; *      Fret.
;	...
;	NTSTATE{}
;	...
;
; rEbx: Arg's
; rEsi: PNTID
; rEdi: NTSTATE
;

; +
;   .
;
pInitSecurityCookie proc C
	mov eax,STACK_FRAME.Next[ebp]
	mov ebx,D[eax + sizeof(STACK_FRAME)]
	assume ebx:PCONTEXT
	%DBG "THREAD(TID: 0x%X, rEip: 0x%X, rEax: 0x%X, rEbx: 0x%X)", [Ebx].rEbx, [Ebx].rEax, [Ebx].rEip, fs:[TEB.Cid.UniqueThread]
	leave
	retn
pInitSecurityCookie endp

.data
g_LockThread		PPVOID ?
g_LockThreadIp		PVOID ?

g_WaitThreadLock	BOOLEAN ?	;   .

.code
_NtDelayExecution struct
Alertable		BOOLEAN ?
DelayInterval	PLARGE_INTEGER ?
_NtDelayExecution ends

pNtDelayExecution proc C
	assume ebx:ptr _NtDelayExecution
	ifdef OPT_THREAD_LIST
		invoke TlsAdd
	endif
	mov eax,D[ebx - 4]	; Ip
	.if g_LockThreadIp == Eax	;       .
		.repeat
			cmp g_WaitThreadLock,FALSE	;   g_LockThread,   
			;  ( (30ms)),   .
		.until Zero?
		mov D[ebx - 4],offset pInitSecurityCookie
		jmp FleaveOk
	.endif
	ret
pNtDelayExecution endp

; ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ USER API ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

_NtQueryInformationProcess struct
ProcessHandle			HANDLE ?
ProcessInformationClass	ULONG ?
ProcessInformation		PVOID ?
ProcessInformationLength	ULONG ?
ReturnLength			PULONG ?
_NtQueryInformationProcess ends

pNtQueryInformationProcess proc C
	assume ebx:ptr _NtQueryInformationProcess
	%DBG "NtQueryInformationProcess(ProcessHandle: 0x%X, ProcessInformationClass: 0x%X)", [Ebx].ProcessInformationClass, [Ebx].ProcessHandle
	retn
pNtQueryInformationProcess endp

_NtTerminateProcess struct
ProcessHandle			HANDLE ?
ExitStatus			NTSTATUS ?
_NtTerminateProcess ends

; +
;
pNtTerminateProcess proc C
	assume ebx:ptr _NtTerminateProcess
	%DBG "NtTerminateProcess(ProcessHandle: 0x%X, ExitStatus: 0x%X)", [Ebx].ExitStatus, [Ebx].ProcessHandle
	retn
pNtTerminateProcess endp

_NtSetInformationProcess struct
ProcessHandle			HANDLE ?
ProcessInformationClass	ULONG ?	; PROCESSINFOCLASS
ProcessInformation		PVOID ?
ProcessInformationLength	ULONG ?
_NtSetInformationProcess ends

pNtSetInformationProcess proc C
	assume ebx:ptr _NtSetInformationProcess
	%DBG "NtSetInformationProcess(ProcessHandle: 0x%X, ProcessInformationClass: 0x%X)", [Ebx].ProcessInformationClass, [Ebx].ProcessHandle
	retn
pNtSetInformationProcess endp

_NtClose struct
ObjectHandle			HANDLE ?
_NtClose ends

$Object	CHAR "NtClose(HANDLE: 0x%X, OBJECT: %wZ)", 13, 10, 0

pNtClose proc
Local Info[MAX_PATH]:WCHAR
	assume ebx:ptr _NtClose
	;   .
	invoke ZwQueryObject, [Ebx].ObjectHandle, ObjectNameInformation, addr Info, MAX_PATH*2, NULL
	.if !Eax
		invoke DbgPrint, addr $Object, [Ebx].ObjectHandle, addr Info
	.endif
	ret
pNtClose endp

_NtOpenProcess struct
ProcessHandle			PHANDLE ?
DesiredAccess			ACCESS_MASK ?
ObjectAttributes		POBJECT_ATTRIBUTES ?
ClientId				PCLIENT_ID ?
_NtOpenProcess ends

pNtOpenProcess proc C
	assume ebx:ptr _NtOpenProcess
	mov ecx,[ebx].ClientId
	.if Ecx
		%DBG "NtOpenProcess(PID: 0x%X)", CLIENT_ID.UniqueProcess
	.endif
	retn
pNtOpenProcess endp
